Перейти к основному содержимому

Quick Start with Angular Gantt

This quick start uses a standalone Angular application and the official wrapper package. It creates Gantt inside a dedicated Angular component and mounts that component in AppComponent, so the example stays minimal while matching a more realistic app structure.

1. Create An Angular Project

Create a standalone Angular app (Angular CLI):

ng new angular-gantt-quick-start --standalone --routing=false --style=css
cd angular-gantt-quick-start

If Angular CLI is not installed yet, install it first (npm install -g @angular/cli).

2. Install Angular Gantt

Install React Gantt as described in the Angular Gantt installation guide.

In this tutorial we use the evaluation package:

npm install @dhtmlx/trial-angular-gantt

or

yarn add @dhtmlx/trial-angular-gantt

If you already use the Professional package, replace @dhtmlx/trial-angular-gantt with @dhx/angular-gantt in the commands and imports.

3. Add Global Styles

Open src/styles.css and add the Gantt styles:

src/styles.css
@import "@dhtmlx/trial-angular-gantt/dist/angular-gantt.css";

html,
body {
height: 100%;
margin: 0;
}

app-root {
display: block;
height: 100vh;
}

This quick start uses a global CSS import (src/styles.css), so you do not need ViewEncapsulation.None in AppComponent.

If you later move the Gantt CSS import (or overrides for internal Gantt classes such as .dhx-gantt-root) into a component stylesheet, Angular's default style encapsulation may scope those selectors. In that case, set encapsulation: ViewEncapsulation.None on that component, or keep the styles global.

4. Add Demo Data

Create src/app/demo-data.ts.

The wrapper exports SerializedTask and SerializedLink - the recommended types for task/link data held outside gantt. Dates can be strings or Date objects.

import type { SerializedTask, SerializedLink } from '@dhtmlx/trial-angular-gantt';

export const tasks: SerializedTask[] = [
{
id: 1,
text: 'Office itinerancy',
type: 'project',
start_date: new Date(2026, 1, 2).toISOString(),
duration: 10,
progress: 0.4,
open: true,
parent: 0,
},
{
id: 2,
text: 'Planning',
start_date: new Date(2026, 1, 2).toISOString(),
duration: 4,
progress: 0.6,
parent: 1,
},
{
id: 3,
text: 'Implementation',
start_date: new Date(2026, 1, 6).toISOString(),
duration: 5,
progress: 0.2,
parent: 1,
},
];

export const links: SerializedLink[] = [{ id: 1, source: 2, target: 3, type: '0' }];

5. Create A Gantt Component

Create src/app/gantt-chart.component.ts:

src/app/gantt-chart.component.ts
import { Component } from '@angular/core';
import {
DhxGanttComponent,
type AngularGanttDataConfig,
} from '@dhtmlx/trial-angular-gantt';

import { links, tasks } from './demo-data';

@Component({
selector: 'app-gantt-chart',
standalone: true,
imports: [DhxGanttComponent],
host: { style: 'display:block;height:100%;' },
template: `
<dhx-gantt
style={{display: 'block', height: '100%'}}
[tasks]="tasks"
[links]="links"
[config]="config"
[data]="dataConfig">
</dhx-gantt>
`,
})
export class GanttChartComponent {
tasks = tasks;
links = links;

config = {
columns: [
{ name: 'text', tree: true, width: '*' },
{ name: 'start_date', label: 'Start', align: 'center' },
{ name: 'duration', label: 'Duration', align: 'center' },
{ name: 'add', width: 44 },
],
};

dataConfig: AngularGanttDataConfig = {
save: (entity, action, item, id) => {
console.log('save', { entity, action, item, id });
},
};
}

6. Render Gantt In The App Shell

Replace src/app/app.component.ts:

src/app/app.component.ts
import { Component } from '@angular/core';
import { GanttChartComponent } from './gantt-chart.component';

@Component({
selector: 'app-root',
standalone: true,
imports: [GanttChartComponent],
template: `<app-gantt-chart></app-gantt-chart>`,
})
export class AppComponent {}

7. Start The App

ng serve

Open http://localhost:4200. You should see a working Gantt chart that logs edits through data.save.

If you are adding Gantt to an existing app, keep your current AppComponent and place <app-gantt-chart> in the target page/component instead. Make sure the parent layout provides a height to the Gantt area.

Optional: Minimal Local Save Handling

As a next step, replace logging with local array synchronization in src/app/gantt-chart.component.ts:

src/app/gantt-chart.component.ts
dataConfig: AngularGanttDataConfig = {
save: (entity, action, item, id) => {
if (entity === 'task') {
if (action === 'create') this.tasks = [...this.tasks, item];
if (action === 'update') {
this.tasks = this.tasks.map((task) => String(task.id) === String(id) ? { ...task, ...item } : task);
}
if (action === 'delete') {
this.tasks = this.tasks.filter((task) => String(task.id) !== String(id));
}
}

if (entity === 'link') {
if (action === 'create') this.links = [...this.links, item];
if (action === 'update') {
this.links = this.links.map((link) => String(link.id) === String(id) ? { ...link, ...item } : link);
}
if (action === 'delete') {
this.links = this.links.filter((link) => String(link.id) !== String(id));
}
}
},
};

For multi-change operations (for example auto-scheduling), prefer data.batchSave and handle grouped updates instead of one-by-one callbacks.

Continue With

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

Quick Start with Vue Gantt

заметка

This tutorial covers the Vue wrapper included in the Commercial, Enterprise, and Ultimate editions of DHTMLX Gantt. If you are using the Individual or GPL edition, follow the alternative guide: How to Start with Vue.

The Vue Gantt component is the official wrapper for DHTMLX Gantt. This guide walks you through creating a small Vue 3 + Vite application and rendering a basic Gantt chart using the trial package.

If you're new to Vue, start with the official Vue documentation.

Check a complete working project that follows this tutorial on GitHub.

Prerequisites

  • Node.js installed
  • npm or Yarn
  • Vue 3 project (this page shows how to create one with Vite)
  • Vue Gantt package access (evaluation or professional)

1. Create A Vue 3 Project

npm create vite@latest vue-gantt-quick-start -- --template vue-ts
cd vue-gantt-quick-start
npm install

If you prefer Yarn, replace the install step with yarn.

2. Install Vue Gantt

Install Vue Gantt as described in the Vue Gantt installation guide.

In this tutorial we use the evaluation package:

npm install @dhtmlx/trial-vue-gantt

or

yarn add @dhtmlx/trial-vue-gantt

If you already use the Professional package, replace @dhtmlx/trial-vue-gantt with @dhx/vue-gantt in the commands and imports.

3. Add Demo Data

Create src/demoData.ts (for externally-owned data in Vue state, prefer SerializedTask / SerializedLink):

src/demoData.ts
import type { SerializedLink, SerializedTask } from "@dhtmlx/trial-vue-gantt";

export const tasks: SerializedTask[] = [
{
id: 1,
text: "Office itinerancy",
type: "project",
start_date: new Date(2026, 0, 5),
duration: 10,
progress: 0.4,
open: true,
parent: 0
},
{
id: 2,
text: "Planning",
start_date: new Date(2026, 0, 5),
duration: 4,
progress: 0.6,
parent: 1
}
];

export const links: SerializedLink[] = [{ id: 1, source: 1, target: 2, type: "0" }];

4. Create A Gantt Component

Create src/components/GanttChart.vue:

src/components/GanttChart.vue
<script setup lang="ts">
import { ref } from "vue";
import VueGantt, {
type SerializedLink,
type SerializedTask,
type VueGanttDataConfig
} from "@dhtmlx/trial-vue-gantt";
import "@dhtmlx/trial-vue-gantt/dist/vue-gantt.css";

import { links as initialLinks, tasks as initialTasks } from "../demoData";

const tasks = ref<SerializedTask[]>(initialTasks);
const links = ref<SerializedLink[]>(initialLinks);

const data: VueGanttDataConfig = {
save: (entity, action, item, id) => {
console.log("save", { entity, action, item, id });
}
};
</script>

<template>
<div style={{height: '100%', width: '100%'}}>
<VueGantt :tasks="tasks" :links="links" :data="data" />
</div>
</template>

If you use the professional package, replace both imports:

  • @dhtmlx/trial-vue-gantt -> @dhx/vue-gantt
  • @dhtmlx/trial-vue-gantt/dist/vue-gantt.css -> @dhx/vue-gantt/dist/vue-gantt.css

5. Render Gantt In The App Shell

Replace src/App.vue:

src/App.vue
<script setup lang="ts">
import GanttChart from "./components/GanttChart.vue";
</script>

<template>
<div style={{height: '100vh', width: '100vw'}}>
<GanttChart />
</div>
</template>

6. Start The App

npm run dev

Open the local Vite URL. You should see a working Gantt chart and console logs when you edit tasks or links.

If you are adding Gantt to an existing app, keep your current App.vue layout and render <GanttChart /> in the target page/component. Make sure the parent layout provides a height to the Gantt area.

7. (Optional) Replace Logging With Local Save Handling

Use this when you want Vue state to stay in sync with chart edits before adding a backend or store. Update src/components/GanttChart.vue.

const data: VueGanttDataConfig = {
save: (entity, action, item, id) => {
if (entity === "task") {
if (action === "create") tasks.value = [...tasks.value, item as SerializedTask];
if (action === "update") tasks.value = tasks.value.map(t => String(t.id) === String(id) ? item as SerializedTask : t);
if (action === "delete") tasks.value = tasks.value.filter(t => String(t.id) !== String(id));
}

if (entity === "link") {
if (action === "create") links.value = [...links.value, item as SerializedLink];
if (action === "update") links.value = links.value.map(l => String(l.id) === String(id) ? item as SerializedLink : l);
if (action === "delete") links.value = links.value.filter(l => String(l.id) !== String(id));
}
}
};

For multi-change operations (for example auto-scheduling), prefer data.batchSave.

Result

You now have a Vue 3 app rendering the official Vue Gantt wrapper with:

  • reactive tasks and links props
  • wrapper CSS imported
  • data.save callback wiring for user edits

This is the same minimal example used in the GitHub demo project.

GitHub demo repository

A complete working project that follows this tutorial is provided on GitHub.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

Быстрый старт с React Gantt

Быстрый старт с React Gantt

заметка

Этот туториал охватывает обертку React, включенную в издания Commercial, Enterprise и Ultimate DHTMLX Gantt. Если вы используете Individual или GPL издания, следуйте альтернативному руководству: Как начать с React.

Компонент React Gantt является официальной оберткой для DHTMLX Gantt. Этот гид проведет вас через создание небольшого приложения на React и вывод базовой диаграммы Gantt с использованием пробного пакета.

Если вы новичок в React, начните с официальной документации React. См. полностью работающий проект, следующий этому руководству, на GitHub.

Требования к версии

  • React 18 или новее

Создание нового проекта на React

Чтобы создать проект на React и перейти в директорию проекта, выполните следующие команды:

npm create vite@latest react-gantt-quick-start -- --template react-ts
cd react-gantt-quick-start

Установка React Gantt

Установите React Gantt, как описано в руководстве по установке React Gantt.

В этом туториале мы используем пробный пакет:

npm install @dhtmlx/trial-react-gantt

или

yarn add @dhtmlx/trial-react-gantt

Если у вас уже используется Professional-пакет, замените @dhtmlx/trial-react-gantt на @dhx/react-gantt в командах и импортируемых элементах.

Добавление демонстрационных данных

Для этого примера мы будем использовать статические данные. Создайте файл src/demoData.ts:

import type { Task, Link } from '@dhtmlx/trial-react-gantt';

export const tasks: Task[] = [
{ id: 1, text: "Office itinerancy", type: "project", start_date: new Date(2025, 3, 2), duration: 17, progress: 0.4, parent: 0, open: true },
...
];

export const links: Link[] = [
{ id: 2, source: 2, target: 3, type: "0" },
...
];

Создание компонента Gantt

Чтобы добавить компонент Gantt, создайте файл src/components/Gantt/Gantt.tsx со следующим содержимым:

import Gantt, {
ReactGanttRef,
Task,
Link,
GanttConfig
} from '@dhtmlx/trial-react-gantt';

import '@dhtmlx/trial-react-gantt/dist/react-gantt.css';
import { useRef } from 'react';

export interface GanttProps {
tasks: Task[];
links: Link[].
}

export default function GanttChart({ tasks, links }: GanttProps) {
const ganttRef = useRef<ReactGanttRef>(null);

const config: GanttConfig = {
grid_width: 500,
scale_height: 90,
scales: [
{ unit: "year", step: 1, date: "%Y" },
{ unit: "month", step: 1, date: "%M" },
{ unit: "day", step: 1, date: "%d %M" }
]
};

return (
<Gantt
ref={ganttRef}
tasks={tasks}
links={links}
config={config}
data={{
save: (entity, action, data, id) => {
console.log(`${entity} - ${action} - ${id}`, data);
}
}}
/>
);
}

Отображение Gantt в приложении

Чтобы отобразить Gantt, замените код src/App.tsx на следующий:

import GanttChart from './components/Gantt/Gantt';
import { tasks, links } from './demoData';

export default function App() {
return (
<div style={{ height: "100vh", width: "100vw" }}>
<GanttChart tasks={tasks} links={links} />
</div>
);
}

После этого запустите приложение командой ниже:

npm run dev

На данный момент у вас есть полностью работающее приложение на React + DHTMLX Gantt.

Эта настройка представляет собой минимальную конфигурацию, которая необходима для:

  • отобразить диаграмму Gantt
  • отображать задачи и связи
  • применить базовую конфигурацию масштабирования
  • прикрепить экземпляр Gantt через React ref
  • получать события через обратный вызов data.save

Это тот же минимальный пример, использованный в демо-проекте на GitHub.

Далее вы можете продолжить, добавляя более продвинутые функции:

  • синхронизацию данных с состоянием React
  • загрузку/сохранение данных с вашего бэкэнда
  • добавление шаблонов и собственных рендереров
  • включение плагинов (авто-расписание, критический путь)
  • добавление ресурсов, календарей или группировки

Следующие разделы поочередно вводят эти возможности.

Использование состояния React в качестве источника истины

(рекомендуется для большинства приложений на React)

В реальных приложениях задачи и связи обычно поступают из состояния React. Ниже приведён полный пример, в котором Gantt отправляет изменения обратно в React через обратный вызов data.save.

import { useState } from "react";
import Gantt from "@dhtmlx/trial-react-gantt";
import "@dhtmlx/trial-react-gantt/dist/react-gantt.css";
import { tasks as initialTasks, links as initialLinks } from "./demoData";

export default function App() {
const [tasks, setTasks] = useState(initialTasks);
const [links, setLinks] = useState(initialLinks);

return (
<div style={{ height: "100vh" }}>
<Gantt
tasks={tasks}
links={links}
data={{
save: (entity, action, item, id) => {
if (entity === "task") {
if (action === "create") setTasks(tasks => [...tasks, item]);
if (action === "update") setTasks(tasks => tasks.map(x => x.id === id ? item : x));
if (action === "delete") setTasks(tasks => tasks.filter(x => x.id !== id));
}
if (entity === "link") {
if (action === "create") setLinks(links => [...links, item]);
if (action === "update") setLinks(links => links.map(x => x.id === id ? item : x));
if (action === "delete") setLinks(links => links.filter(x => x.id !== id));
}
}
}}
/>
</div>
);
}

Почему стоит выбрать этот режим

  • React всегда видит те же данные, что и UI Gantt
  • Работает безупречно с Redux / Zustand / Jotai / MobX
  • Легко синхронизируется с backend API

Альтернативный режим: Gantt как источник истины

(полезно для очень больших наборов данных или тяжелого авто-расписания)

В этом режиме React не владеет задачами/связями.

<Gantt
data={{
load: "/api/gantt-data",
save: "/api/gantt-data"
}}
/>

Когда предпочтительнее этот режим

  • Десятки тысяч задач
  • Много обновлений авто-расписания
  • Вы хотите минимальные витки перерисовки React

Использование шаблонов

(возвращают элементы React из функций шаблонов)

Шаблоны позволяют настраивать почти каждую часть графика.

const templates = {
task_text: (start, end, task) => (
<span style={{ color: "red" }}>#{task.id}: {task.text}</span>
)
};

<Gantt templates={templates} />

Дополнительная информация

См. полную секцию здесь: Документация по шаблонам React Gantt.

Демо-репозиторий GitHub

Полностью рабочий проект, следующий этому руководству, доступен на GitHub: https://github.com/dhtmlx/react-gantt-quick-start

Дальнейшие шаги

  • Изучите все доступные свойства React Gantt
  • Изучайте расширенные возможности Gantt в [Руководства]
Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.